=== debian/changelog ===
openio-sds (3.2.4-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 15:52:20 +0000
