## openio-sds 4.1.5

=== debian/changelog ===
openio-sds (4.1.5-4) stretch; urgency=medium

  * Removed cliff-tablib runtime dependency

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 27 Nov 2017 12:47:37 +0000

openio-sds (4.1.5-3) stretch; urgency=medium

  * Update libleveldb dependency

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 02 Nov 2017 13:59:59 +0000

openio-sds (4.1.5-2) stretch; urgency=medium

  * Update libjson dependency

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 02 Nov 2017 13:30:10 +0000

openio-sds (4.1.5-1) stretch; urgency=medium

  * Rebuilt for Debian Stretch

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 30 Oct 2017 14:10:47 +0000
